package android.hello;

import java.util.List;

import sparta.checkers.quals.FlowSinks;
import sparta.checkers.quals.FlowSources;
import sparta.checkers.quals.PolyFlowSinks;
import sparta.checkers.quals.PolyFlowSources;
import sparta.checkers.quals.FlowSources.FlowSource;
import android.hello.KMeans;

public /*@PolyFlowSinks @PolyFlowSources*/ class MachineLearner {

	public enum State
	{
		Smooth,Bump,Brake;
	}

	private @SuppressWarnings("flow") @FlowSources(FlowSource.ACCELEROMETER) float bumpThreshold;
	private @SuppressWarnings("flow") @FlowSources(FlowSource.ACCELEROMETER) float brakeThreshold;

	public MachineLearner()
	{
		bumpThreshold = 0;
		brakeThreshold = 0;
	}
	 public MachineLearner(List<Float> ZStd,List<Float> YAmp)
	{
		BumpTrain(ZStd);
		BrakeTrain(YAmp);
	}
	public @FlowSources(FlowSource.ACCELEROMETER) float BumpTrain( @SuppressWarnings("flow")  @FlowSources(FlowSource.ACCELEROMETER) List<Float> ZStd) //List of Standard Deviations in Z, for each window
	{
		 KMeans km = new KMeans();
		km.setPoints(ZStd);
		float thresh = km.clusterIt();
		bumpThreshold= thresh;
		return thresh;
	}
	public @FlowSources(FlowSource.ACCELEROMETER) float BrakeTrain(@SuppressWarnings("flow")  @FlowSources(FlowSource.ACCELEROMETER) List<Float> YAmp) //List of Amplitudes in Z, for each window
	{
		KMeans km = new KMeans();
		km.setPoints(YAmp);
		@SuppressWarnings("flow") float thresh = km.clusterIt();
		bumpThreshold= thresh;
		return thresh;
	}
	public @FlowSources(FlowSource.ACCELEROMETER)  State BumpClassify(@SuppressWarnings("flow") @FlowSources(FlowSource.ACCELEROMETER) Float ZStd)
	{
		@SuppressWarnings("flow")
		@FlowSources @FlowSinks boolean temp;
		temp= (@FlowSources @FlowSinks boolean) (ZStd > bumpThreshold);
		if(temp)
			return State.Bump;
		else
			return State.Smooth;
	}
	public @FlowSources(FlowSource.ACCELEROMETER) State BrakeClassify(@SuppressWarnings("flow")  @FlowSources(FlowSource.ACCELEROMETER) Float YAmp)
	{
		@SuppressWarnings("flow") @FlowSinks @FlowSources boolean temp;
		temp= (@FlowSources @FlowSinks boolean)(YAmp > brakeThreshold);
		if(temp)
			return State.Brake;
		else
			return State.Smooth;
	}
	
}
