package my.android.mouse;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Context;
import android.os.Bundle;

import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.util.Log;
import android.view.View;
import android.view.Window;
import sparta.checkers.quals.*;

import sparta.checkers.quals.FlowSources.FlowSource;
import sparta.checkers.quals.FlowSinks.FlowSink;

@TargetApi(3)
public class AndroidMouseActivity extends Activity implements
		SensorEventListener {
	private SensorManager sensorManager;
	private boolean writeToFileSystem = false;

	/** Called when the activity is first created. */

	public void onCreate(Bundle savedInstanceState) {
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.main);
		
		sensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);

		@SuppressWarnings("flow") //this is allowed to register a listener
		@FlowSinks(FlowSink.ANY) @FlowSources SensorEventListener listener = this;
		@SuppressWarnings("flow") // Allowed to register the accelerometer
		@FlowSinks(FlowSink.ANY) @FlowSources Sensor sensor = sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
		@SuppressWarnings("flow") //Allowed to register the listener with delay
		@FlowSinks(FlowSink.ANY) @FlowSources int delay = SensorManager.SENSOR_DELAY_GAME;
		sensorManager.registerListener(listener, sensor, delay);

	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		// /CLOVER:FLUSH
	}

	public void onSensorChanged(
		@FlowSources(FlowSource.ACCELEROMETER) SensorEvent event) {
		@SuppressWarnings("flow")// Conditional statement
		@FlowSources @FlowSinks boolean isAccel = event.sensor.getType() == Sensor.TYPE_ACCELEROMETER;
		if (isAccel) {
			@SuppressWarnings("flow")
			@FlowSources(FlowSource.ACCELEROMETER) SensorEvent accelEvent = event;
			logAccelerometer(accelEvent);
		}

	}
	
//	private void logAccelerometer(@FlowSources(FlowSource.ACCELEROMETER) SensorEvent accelEvent) {
	private void logAccelerometer(SensorEvent accelEvent) {
		
		
//		@FlowSources(FlowSource.ACCELEROMETER) @FlowSinks float[] values = accelEvent.values;
		float[] values = accelEvent.values;
		// Movement
		float x = values[0];
		float y = values[1];
		float z = values[2];

		String accelStr = x + " " + y + " " + z;
		
//		@SuppressWarnings("flow") // String is safe to write to LOGCAT
//		@FlowSinks(FlowSink.LOGCAT) @FlowSources String safeTag="accelo";
//		
//		@SuppressWarnings("flow") // String is safe to write to LOGCAT
//		@FlowSinks(FlowSink.LOGCAT) @FlowSources String safeAccelStr = accelStr;
//		Log.i(safeTag, safeAccelStr);


		Log.i("accelo", accelStr);

		if (writeToFileSystem) {
			@SuppressWarnings("flow") // you can create a new file name "log.txt"
			@FlowSinks(FlowSink.FILESYSTEM) @FlowSources String dirName = "log";
			@SuppressWarnings("flow") // you can create a new file name "log.txt"
			@FlowSinks(FlowSink.FILESYSTEM) @FlowSources String fileName = "log.txt";

			@FlowSinks(FlowSink.FILESYSTEM) @FlowSources String path=this.getDir(dirName, Context.MODE_PRIVATE) + fileName;
			
			@SuppressWarnings("flow") //PolyFlow Constructor bug
			@FlowSinks(FlowSink.FILESYSTEM) @FlowSources File f = new File(path);
			try {
				f.createNewFile();
				@SuppressWarnings("flow") //PolyFlow Constructor bug
				@FlowSinks(FlowSink.FILESYSTEM) @FlowSources FileWriter fw = new FileWriter(f);

				@SuppressWarnings("flow") // Okay to write constant string to filesystem
				@FlowSources @FlowSinks(FlowSink.FILESYSTEM) String toWrite = "logged!";
				fw.write(toWrite);
				
				//MALWARE
				fw.write(accelStr);
				
				
//				@FlowSources @FlowSinks(FlowSink.FILESYSTEM) String str2 = str;
//				fw.write(str2);
				
				//MALWARE
				
				fw.close();

			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			// write the bytes in file

		}
	}

	public void leftClick(View v) {
		@SuppressWarnings("flow")
		@FlowSources @FlowSinks(FlowSink.LOGCAT) String lc = "leftclick";
		Log.i(lc, lc);	}

	public void rightClick(View v) {
		@SuppressWarnings("flow")
		@FlowSources @FlowSinks(FlowSink.LOGCAT) String rc = "rightclick";
		Log.i(rc, rc);
	}

	public void onAccuracyChanged(Sensor sensor, int accuracy) {

	}

	protected void onResume() {
		super.onResume();
		@SuppressWarnings("flow") //this is allowed to register a listener
		@FlowSinks(FlowSink.ANY) @FlowSources SensorEventListener listener = this;
		@SuppressWarnings("flow") // Allowed to register the accelerometer
		@FlowSinks(FlowSink.ANY) @FlowSources Sensor sensor = sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
		@SuppressWarnings("flow") //Allowed to register the listener with delay
		@FlowSinks(FlowSink.ANY) @FlowSources int delay = SensorManager.SENSOR_DELAY_GAME;
		sensorManager.registerListener(listener, sensor, delay);

	}

	protected void onPause() {
		// unregister listener
		@SuppressWarnings("flow")
		@FlowSinks(FlowSink.ANY) @FlowSources SensorEventListener listener = this;
		sensorManager.unregisterListener(listener);
		super.onStop();
	}
}